/* mk_dt.c - make dither tables from 8bit to 5bit
   Copyright (C) 1993 NIIMI Satoshi

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <stdio.h>
#include <stdlib.h>
#include <doslib.h>
#include <iocslib.h>

static char rcsid[] = "$Id: mk_dt.c,v 1.1 1993/04/19 15:57:38 sa2c Exp $";

char dither_table[4][4] =
{
  0, 4, 1, 5,
  6, 2, 7, 3,
  1, 5, 0, 4,
  7, 3, 6, 2,
};

int
main ()
{
  int x, y, col;
  int dat;

  printf ("unsigned char dither_table[4][4][256] =\n{\n");
  for (y = 0; y < 4; y++)
    {
      printf ("  {\n");
      for (x = 0; x < 4; x++)
	{
	  printf ("    {\n");
	  for (col = 0; col < 256; col++)
	    {
	      if ((col & 15) == 0)
		printf ("      ");
	      dat = col + dither_table[y][x];
	      dat = (dat > 255) ? 255 : dat;
	      dat >>= 3;
	      printf ("%2d, ", dat);
	      if ((col & 15) == 15)
		printf ("\n");
	    }
	  printf ("    },\n");
	}
      printf ("  },\n");
    }
  printf ("};\n");
  return 0;
}
